/*
 * ICQHost.CMD
 *
 * This script is designed to be used as a pwICQ's helper associated with the
 * events "User online" and "User offline" adding/removing the user IP from
 * the hosts file. This enable the access to the other user FTP/HTTP server
 * using the nickname.
 *
 * The line to add in the Execute box of this events:
 *
 * [path]\scripts2\ICQHost.cmd %n %d %i
 *
 * Note: The option "Use hosts first" must be enabled in TCP-IP configuration
 *
 */

parse arg nick mode addr

 ok      = RxFuncAdd('SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs')
 ok      = SysLoadFuncs()

 etcpath = Value( 'ETC',,'OS2ENVIRONMENT' )
 tmppath = Value( 'TMP',,'OS2ENVIRONMENT' )

 hfile   = etcpath || '\HOSTS.'
 logfile = tmppath || '\ICQHOST.LOG'

 if mode = 1
   then line = ' '||nick||' Available     ('||addr||')'
   else line = ' '||nick||' Unavailable   ('||addr||')'

 do while lineout(logfile,date()||' '||time()||line) <> 0
   ok = SysSleep(0.4)
 end

 if mode = 1
    then ok = addhost(nick,addr)
    else ok = addhost(nick,"")

 ok = stream(logfile,'c','close')

return ok

addhost:

parse arg nick, addr

   tfile = SysTempFileName(tmppath || '\HST?????.TMP','?')

   do while Lines( hfile ) > 0

       lin  = LineIn( hfile )
       ip   = word(lin,1)
       host = word(lin,2)

       if host <> nick
          then ok  = lineout(tfile,ip||" "||host)

   end

   if(addr <> "")
      then ok = lineout(tfile,strip(addr)||" "||strip(nick))


   ok = stream(hfile,'c','close')
   ok = stream(tfile,'c','close')

   '@copy '||hfile||' '||hfile||'bak > NUL:'
   '@copy '||tfile||' '||hfile||' > NUL:'
   '@del  '||tfile||' > nul:'

return rc

